<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'Instance_IDType' => '\\StructType\\Instance_IDType',
            'InstanceObjectType' => '\\StructType\\InstanceObjectType',
            'Workday_Common_HeaderType' => '\\StructType\\Workday_Common_HeaderType',
            'Response_FilterType' => '\\StructType\\Response_FilterType',
            'Response_ResultsType' => '\\StructType\\Response_ResultsType',
            'Business_Process_Comment_DataType' => '\\StructType\\Business_Process_Comment_DataType',
            'Business_Process_ParametersType' => '\\StructType\\Business_Process_ParametersType',
            'Time_Clock_Event_DataType' => '\\StructType\\Time_Clock_Event_DataType',
            'Put_Time_Clock_Events_RequestType' => '\\StructType\\Put_Time_Clock_Events_RequestType',
            'Put_Time_Clock_Events_ResponseType' => '\\StructType\\Put_Time_Clock_Events_ResponseType',
            'Put_Import_Process_ResponseType' => '\\StructType\\Put_Import_Process_ResponseType',
            'Reported_Time_Block_DataType' => '\\StructType\\Reported_Time_Block_DataType',
            'Import_Reported_Time_Blocks_RequestType' => '\\StructType\\Import_Reported_Time_Blocks_RequestType',
            'Business_Process_Attachment_DataType' => '\\StructType\\Business_Process_Attachment_DataType',
            'Assign_Work_Schedule_DataType' => '\\StructType\\Assign_Work_Schedule_DataType',
            'Assign_Work_Schedule_RequestType' => '\\StructType\\Assign_Work_Schedule_RequestType',
            'Assign_Work_Schedule_ResponseType' => '\\StructType\\Assign_Work_Schedule_ResponseType',
            'Import_Time_Clock_Events_RequestType' => '\\StructType\\Import_Time_Clock_Events_RequestType',
            'Ad_Hoc_Schedule_Event_DataType' => '\\StructType\\Ad_Hoc_Schedule_Event_DataType',
            'Ad_Hoc_Schedule_Event_Meal_DataType' => '\\StructType\\Ad_Hoc_Schedule_Event_Meal_DataType',
            'Import_Ad_Hoc_Schedules_RequestType' => '\\StructType\\Import_Ad_Hoc_Schedules_RequestType',
            'Get_Calculated_Time_Blocks_ResponseType' => '\\StructType\\Get_Calculated_Time_Blocks_ResponseType',
            'Calculated_Time_Block_Request_ReferencesType' => '\\StructType\\Calculated_Time_Block_Request_ReferencesType',
            'Calculated_Time_Block_DataType' => '\\StructType\\Calculated_Time_Block_DataType',
            'Get_Calculated_Time_Blocks_RequestType' => '\\StructType\\Get_Calculated_Time_Blocks_RequestType',
            'Calculated_Time_BlockType' => '\\StructType\\Calculated_Time_BlockType',
            'Calculated_Time_Block_Response_GroupType' => '\\StructType\\Calculated_Time_Block_Response_GroupType',
            'Calculated_Time_Block_Response_DataType' => '\\StructType\\Calculated_Time_Block_Response_DataType',
            'Calculated_Time_Block_Request_CriteriaType' => '\\StructType\\Calculated_Time_Block_Request_CriteriaType',
            'LocationObjectIDType' => '\\StructType\\LocationObjectIDType',
            'Job_ProfileObjectIDType' => '\\StructType\\Job_ProfileObjectIDType',
            'WorkerObjectIDType' => '\\StructType\\WorkerObjectIDType',
            'Custom_Worktag_01ObjectIDType' => '\\StructType\\Custom_Worktag_01ObjectIDType',
            'Custom_Worktag_02ObjectIDType' => '\\StructType\\Custom_Worktag_02ObjectIDType',
            'Custom_Worktag_03ObjectIDType' => '\\StructType\\Custom_Worktag_03ObjectIDType',
            'Custom_Worktag_04ObjectIDType' => '\\StructType\\Custom_Worktag_04ObjectIDType',
            'Custom_Worktag_05ObjectIDType' => '\\StructType\\Custom_Worktag_05ObjectIDType',
            'Project_Plan_TaskObjectIDType' => '\\StructType\\Project_Plan_TaskObjectIDType',
            'ProjectObjectIDType' => '\\StructType\\ProjectObjectIDType',
            'Time_Entry_CodeObjectIDType' => '\\StructType\\Time_Entry_CodeObjectIDType',
            'Supervisory_OrganizationObjectIDType' => '\\StructType\\Supervisory_OrganizationObjectIDType',
            'Cost_CenterObjectIDType' => '\\StructType\\Cost_CenterObjectIDType',
            'RegionObjectIDType' => '\\StructType\\RegionObjectIDType',
            'Custom_OrganizationObjectIDType' => '\\StructType\\Custom_OrganizationObjectIDType',
            'Unique_IdentifierObjectIDType' => '\\StructType\\Unique_IdentifierObjectIDType',
            'Position_ElementObjectIDType' => '\\StructType\\Position_ElementObjectIDType',
            'Work_Schedule_CalendarObjectIDType' => '\\StructType\\Work_Schedule_CalendarObjectIDType',
            'FundObjectIDType' => '\\StructType\\FundObjectIDType',
            'Worker_Time_BlockObjectIDType' => '\\StructType\\Worker_Time_BlockObjectIDType',
            'Time_Tracking_Set_Up_OptionObjectIDType' => '\\StructType\\Time_Tracking_Set_Up_OptionObjectIDType',
            'Time_TypeObjectIDType' => '\\StructType\\Time_TypeObjectIDType',
            'ProgramObjectIDType' => '\\StructType\\ProgramObjectIDType',
            'GrantObjectIDType' => '\\StructType\\GrantObjectIDType',
            'Time_Calculation_TagObjectIDType' => '\\StructType\\Time_Calculation_TagObjectIDType',
            'Business_UnitObjectIDType' => '\\StructType\\Business_UnitObjectIDType',
            'Time_Punch_TypeObjectIDType' => '\\StructType\\Time_Punch_TypeObjectIDType',
            'Custom_Worktag_06ObjectIDType' => '\\StructType\\Custom_Worktag_06ObjectIDType',
            'Custom_Worktag_07ObjectIDType' => '\\StructType\\Custom_Worktag_07ObjectIDType',
            'Custom_Worktag_08ObjectIDType' => '\\StructType\\Custom_Worktag_08ObjectIDType',
            'Custom_Worktag_09ObjectIDType' => '\\StructType\\Custom_Worktag_09ObjectIDType',
            'Custom_Worktag_10ObjectIDType' => '\\StructType\\Custom_Worktag_10ObjectIDType',
            'Custom_Worktag_11ObjectIDType' => '\\StructType\\Custom_Worktag_11ObjectIDType',
            'Custom_Worktag_12ObjectIDType' => '\\StructType\\Custom_Worktag_12ObjectIDType',
            'Custom_Worktag_13ObjectIDType' => '\\StructType\\Custom_Worktag_13ObjectIDType',
            'Custom_Worktag_14ObjectIDType' => '\\StructType\\Custom_Worktag_14ObjectIDType',
            'Custom_Worktag_15ObjectIDType' => '\\StructType\\Custom_Worktag_15ObjectIDType',
            'GiftObjectIDType' => '\\StructType\\GiftObjectIDType',
            'Web_Service_Background_Process_RuntimeObjectIDType' => '\\StructType\\Web_Service_Background_Process_RuntimeObjectIDType',
            'Event_Attachment_CategoryObjectIDType' => '\\StructType\\Event_Attachment_CategoryObjectIDType',
            'LocationObjectType' => '\\StructType\\LocationObjectType',
            'Job_ProfileObjectType' => '\\StructType\\Job_ProfileObjectType',
            'WorkerObjectType' => '\\StructType\\WorkerObjectType',
            'Custom_Worktag_01ObjectType' => '\\StructType\\Custom_Worktag_01ObjectType',
            'Custom_Worktag_02ObjectType' => '\\StructType\\Custom_Worktag_02ObjectType',
            'Custom_Worktag_03ObjectType' => '\\StructType\\Custom_Worktag_03ObjectType',
            'Custom_Worktag_04ObjectType' => '\\StructType\\Custom_Worktag_04ObjectType',
            'Custom_Worktag_05ObjectType' => '\\StructType\\Custom_Worktag_05ObjectType',
            'Project_Plan_TaskObjectType' => '\\StructType\\Project_Plan_TaskObjectType',
            'ProjectObjectType' => '\\StructType\\ProjectObjectType',
            'Time_Entry_CodeObjectType' => '\\StructType\\Time_Entry_CodeObjectType',
            'Supervisory_OrganizationObjectType' => '\\StructType\\Supervisory_OrganizationObjectType',
            'Cost_CenterObjectType' => '\\StructType\\Cost_CenterObjectType',
            'RegionObjectType' => '\\StructType\\RegionObjectType',
            'Custom_OrganizationObjectType' => '\\StructType\\Custom_OrganizationObjectType',
            'Unique_IdentifierObjectType' => '\\StructType\\Unique_IdentifierObjectType',
            'Position_ElementObjectType' => '\\StructType\\Position_ElementObjectType',
            'Work_Schedule_CalendarObjectType' => '\\StructType\\Work_Schedule_CalendarObjectType',
            'FundObjectType' => '\\StructType\\FundObjectType',
            'Worker_Time_BlockObjectType' => '\\StructType\\Worker_Time_BlockObjectType',
            'Time_Tracking_Set_Up_OptionObjectType' => '\\StructType\\Time_Tracking_Set_Up_OptionObjectType',
            'Time_TypeObjectType' => '\\StructType\\Time_TypeObjectType',
            'ProgramObjectType' => '\\StructType\\ProgramObjectType',
            'GrantObjectType' => '\\StructType\\GrantObjectType',
            'Time_Calculation_TagObjectType' => '\\StructType\\Time_Calculation_TagObjectType',
            'Business_UnitObjectType' => '\\StructType\\Business_UnitObjectType',
            'Time_Punch_TypeObjectType' => '\\StructType\\Time_Punch_TypeObjectType',
            'Custom_Worktag_06ObjectType' => '\\StructType\\Custom_Worktag_06ObjectType',
            'Custom_Worktag_07ObjectType' => '\\StructType\\Custom_Worktag_07ObjectType',
            'Custom_Worktag_08ObjectType' => '\\StructType\\Custom_Worktag_08ObjectType',
            'Custom_Worktag_09ObjectType' => '\\StructType\\Custom_Worktag_09ObjectType',
            'Custom_Worktag_10ObjectType' => '\\StructType\\Custom_Worktag_10ObjectType',
            'Custom_Worktag_11ObjectType' => '\\StructType\\Custom_Worktag_11ObjectType',
            'Custom_Worktag_12ObjectType' => '\\StructType\\Custom_Worktag_12ObjectType',
            'Custom_Worktag_13ObjectType' => '\\StructType\\Custom_Worktag_13ObjectType',
            'Custom_Worktag_14ObjectType' => '\\StructType\\Custom_Worktag_14ObjectType',
            'Custom_Worktag_15ObjectType' => '\\StructType\\Custom_Worktag_15ObjectType',
            'GiftObjectType' => '\\StructType\\GiftObjectType',
            'Web_Service_Background_Process_RuntimeObjectType' => '\\StructType\\Web_Service_Background_Process_RuntimeObjectType',
            'Event_Attachment_CategoryObjectType' => '\\StructType\\Event_Attachment_CategoryObjectType',
            'Validation_FaultType' => '\\StructType\\Validation_FaultType',
            'Processing_FaultType' => '\\StructType\\Processing_FaultType',
            'Validation_ErrorType' => '\\StructType\\Validation_ErrorType',
        );
    }
}
