<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Calculated_Time_Block_Response_GroupType StructType
 * Meta informations extracted from the WSDL
 * - documentation: Time Block Response Group
 * @subpackage Structs
 */
class Calculated_Time_Block_Response_GroupType extends AbstractStructBase
{
    /**
     * The Include_Worker
     * Meta informations extracted from the WSDL
     * - documentation: Worker for the calculated time block
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var bool
     */
    public $Include_Worker;
    /**
     * The Include_Date
     * Meta informations extracted from the WSDL
     * - documentation: Calculated Date for the calculated time block.
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var bool
     */
    public $Include_Date;
    /**
     * The Include_In_Out_Time
     * Meta informations extracted from the WSDL
     * - documentation: Calculated In Time (if applicable) for the calculated time block
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var bool
     */
    public $Include_In_Out_Time;
    /**
     * The Include_Calculated_Quantity
     * Meta informations extracted from the WSDL
     * - documentation: Calculated Quantity for the calculated time block
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var bool
     */
    public $Include_Calculated_Quantity;
    /**
     * The Include_Status
     * Meta informations extracted from the WSDL
     * - documentation: Status for the calculated time block
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var bool
     */
    public $Include_Status;
    /**
     * The Include_Deleted
     * Meta informations extracted from the WSDL
     * - documentation: Is Deleted flag for the calculated time block
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var bool
     */
    public $Include_Deleted;
    /**
     * The Include_Calculation_Tags
     * Meta informations extracted from the WSDL
     * - documentation: Calculation Tags for the calculated time block
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var bool
     */
    public $Include_Calculation_Tags;
    /**
     * The Include_Last_Updated
     * Meta informations extracted from the WSDL
     * - documentation: Include Last Updated
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var bool
     */
    public $Include_Last_Updated;
    /**
     * The Include_Worktags
     * Meta informations extracted from the WSDL
     * - documentation: Include Worktags
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var bool
     */
    public $Include_Worktags;
    /**
     * Constructor method for Calculated_Time_Block_Response_GroupType
     * @uses Calculated_Time_Block_Response_GroupType::setInclude_Worker()
     * @uses Calculated_Time_Block_Response_GroupType::setInclude_Date()
     * @uses Calculated_Time_Block_Response_GroupType::setInclude_In_Out_Time()
     * @uses Calculated_Time_Block_Response_GroupType::setInclude_Calculated_Quantity()
     * @uses Calculated_Time_Block_Response_GroupType::setInclude_Status()
     * @uses Calculated_Time_Block_Response_GroupType::setInclude_Deleted()
     * @uses Calculated_Time_Block_Response_GroupType::setInclude_Calculation_Tags()
     * @uses Calculated_Time_Block_Response_GroupType::setInclude_Last_Updated()
     * @uses Calculated_Time_Block_Response_GroupType::setInclude_Worktags()
     * @param bool $include_Worker
     * @param bool $include_Date
     * @param bool $include_In_Out_Time
     * @param bool $include_Calculated_Quantity
     * @param bool $include_Status
     * @param bool $include_Deleted
     * @param bool $include_Calculation_Tags
     * @param bool $include_Last_Updated
     * @param bool $include_Worktags
     */
    public function __construct($include_Worker = null, $include_Date = null, $include_In_Out_Time = null, $include_Calculated_Quantity = null, $include_Status = null, $include_Deleted = null, $include_Calculation_Tags = null, $include_Last_Updated = null, $include_Worktags = null)
    {
        $this
            ->setInclude_Worker($include_Worker)
            ->setInclude_Date($include_Date)
            ->setInclude_In_Out_Time($include_In_Out_Time)
            ->setInclude_Calculated_Quantity($include_Calculated_Quantity)
            ->setInclude_Status($include_Status)
            ->setInclude_Deleted($include_Deleted)
            ->setInclude_Calculation_Tags($include_Calculation_Tags)
            ->setInclude_Last_Updated($include_Last_Updated)
            ->setInclude_Worktags($include_Worktags);
    }
    /**
     * Get Include_Worker value
     * @return bool|null
     */
    public function getInclude_Worker()
    {
        return $this->Include_Worker;
    }
    /**
     * Set Include_Worker value
     * @param bool $include_Worker
     * @return \StructType\Calculated_Time_Block_Response_GroupType
     */
    public function setInclude_Worker($include_Worker = null)
    {
        // validation for constraint: boolean
        if (!is_null($include_Worker) && !is_bool($include_Worker)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($include_Worker)), __LINE__);
        }
        $this->Include_Worker = $include_Worker;
        return $this;
    }
    /**
     * Get Include_Date value
     * @return bool|null
     */
    public function getInclude_Date()
    {
        return $this->Include_Date;
    }
    /**
     * Set Include_Date value
     * @param bool $include_Date
     * @return \StructType\Calculated_Time_Block_Response_GroupType
     */
    public function setInclude_Date($include_Date = null)
    {
        // validation for constraint: boolean
        if (!is_null($include_Date) && !is_bool($include_Date)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($include_Date)), __LINE__);
        }
        $this->Include_Date = $include_Date;
        return $this;
    }
    /**
     * Get Include_In_Out_Time value
     * @return bool|null
     */
    public function getInclude_In_Out_Time()
    {
        return $this->Include_In_Out_Time;
    }
    /**
     * Set Include_In_Out_Time value
     * @param bool $include_In_Out_Time
     * @return \StructType\Calculated_Time_Block_Response_GroupType
     */
    public function setInclude_In_Out_Time($include_In_Out_Time = null)
    {
        // validation for constraint: boolean
        if (!is_null($include_In_Out_Time) && !is_bool($include_In_Out_Time)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($include_In_Out_Time)), __LINE__);
        }
        $this->Include_In_Out_Time = $include_In_Out_Time;
        return $this;
    }
    /**
     * Get Include_Calculated_Quantity value
     * @return bool|null
     */
    public function getInclude_Calculated_Quantity()
    {
        return $this->Include_Calculated_Quantity;
    }
    /**
     * Set Include_Calculated_Quantity value
     * @param bool $include_Calculated_Quantity
     * @return \StructType\Calculated_Time_Block_Response_GroupType
     */
    public function setInclude_Calculated_Quantity($include_Calculated_Quantity = null)
    {
        // validation for constraint: boolean
        if (!is_null($include_Calculated_Quantity) && !is_bool($include_Calculated_Quantity)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($include_Calculated_Quantity)), __LINE__);
        }
        $this->Include_Calculated_Quantity = $include_Calculated_Quantity;
        return $this;
    }
    /**
     * Get Include_Status value
     * @return bool|null
     */
    public function getInclude_Status()
    {
        return $this->Include_Status;
    }
    /**
     * Set Include_Status value
     * @param bool $include_Status
     * @return \StructType\Calculated_Time_Block_Response_GroupType
     */
    public function setInclude_Status($include_Status = null)
    {
        // validation for constraint: boolean
        if (!is_null($include_Status) && !is_bool($include_Status)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($include_Status)), __LINE__);
        }
        $this->Include_Status = $include_Status;
        return $this;
    }
    /**
     * Get Include_Deleted value
     * @return bool|null
     */
    public function getInclude_Deleted()
    {
        return $this->Include_Deleted;
    }
    /**
     * Set Include_Deleted value
     * @param bool $include_Deleted
     * @return \StructType\Calculated_Time_Block_Response_GroupType
     */
    public function setInclude_Deleted($include_Deleted = null)
    {
        // validation for constraint: boolean
        if (!is_null($include_Deleted) && !is_bool($include_Deleted)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($include_Deleted)), __LINE__);
        }
        $this->Include_Deleted = $include_Deleted;
        return $this;
    }
    /**
     * Get Include_Calculation_Tags value
     * @return bool|null
     */
    public function getInclude_Calculation_Tags()
    {
        return $this->Include_Calculation_Tags;
    }
    /**
     * Set Include_Calculation_Tags value
     * @param bool $include_Calculation_Tags
     * @return \StructType\Calculated_Time_Block_Response_GroupType
     */
    public function setInclude_Calculation_Tags($include_Calculation_Tags = null)
    {
        // validation for constraint: boolean
        if (!is_null($include_Calculation_Tags) && !is_bool($include_Calculation_Tags)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($include_Calculation_Tags)), __LINE__);
        }
        $this->Include_Calculation_Tags = $include_Calculation_Tags;
        return $this;
    }
    /**
     * Get Include_Last_Updated value
     * @return bool|null
     */
    public function getInclude_Last_Updated()
    {
        return $this->Include_Last_Updated;
    }
    /**
     * Set Include_Last_Updated value
     * @param bool $include_Last_Updated
     * @return \StructType\Calculated_Time_Block_Response_GroupType
     */
    public function setInclude_Last_Updated($include_Last_Updated = null)
    {
        // validation for constraint: boolean
        if (!is_null($include_Last_Updated) && !is_bool($include_Last_Updated)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($include_Last_Updated)), __LINE__);
        }
        $this->Include_Last_Updated = $include_Last_Updated;
        return $this;
    }
    /**
     * Get Include_Worktags value
     * @return bool|null
     */
    public function getInclude_Worktags()
    {
        return $this->Include_Worktags;
    }
    /**
     * Set Include_Worktags value
     * @param bool $include_Worktags
     * @return \StructType\Calculated_Time_Block_Response_GroupType
     */
    public function setInclude_Worktags($include_Worktags = null)
    {
        // validation for constraint: boolean
        if (!is_null($include_Worktags) && !is_bool($include_Worktags)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($include_Worktags)), __LINE__);
        }
        $this->Include_Worktags = $include_Worktags;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Calculated_Time_Block_Response_GroupType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
