<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Get_Calculated_Time_Blocks_RequestType StructType
 * Meta informations extracted from the WSDL
 * - documentation: Get Calculated Time Blocks Request
 * @subpackage Structs
 */
class Get_Calculated_Time_Blocks_RequestType extends AbstractStructBase
{
    /**
     * The Request_References
     * Meta informations extracted from the WSDL
     * - documentation: Time Block Request References
     * - minOccurs: 0
     * @var \StructType\Calculated_Time_Block_Request_ReferencesType
     */
    public $Request_References;
    /**
     * The Request_Criteria
     * Meta informations extracted from the WSDL
     * - documentation: Time Block Request Criteria
     * - minOccurs: 0
     * @var \StructType\Calculated_Time_Block_Request_CriteriaType
     */
    public $Request_Criteria;
    /**
     * The Response_Filter
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\Response_FilterType
     */
    public $Response_Filter;
    /**
     * The Response_Group
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\Calculated_Time_Block_Response_GroupType
     */
    public $Response_Group;
    /**
     * The version
     * Meta informations extracted from the WSDL
     * - ref: wd:version
     * @var string
     */
    public $version;
    /**
     * Constructor method for Get_Calculated_Time_Blocks_RequestType
     * @uses Get_Calculated_Time_Blocks_RequestType::setRequest_References()
     * @uses Get_Calculated_Time_Blocks_RequestType::setRequest_Criteria()
     * @uses Get_Calculated_Time_Blocks_RequestType::setResponse_Filter()
     * @uses Get_Calculated_Time_Blocks_RequestType::setResponse_Group()
     * @uses Get_Calculated_Time_Blocks_RequestType::setVersion()
     * @param \StructType\Calculated_Time_Block_Request_ReferencesType $request_References
     * @param \StructType\Calculated_Time_Block_Request_CriteriaType $request_Criteria
     * @param \StructType\Response_FilterType $response_Filter
     * @param \StructType\Calculated_Time_Block_Response_GroupType $response_Group
     * @param string $version
     */
    public function __construct(\StructType\Calculated_Time_Block_Request_ReferencesType $request_References = null, \StructType\Calculated_Time_Block_Request_CriteriaType $request_Criteria = null, \StructType\Response_FilterType $response_Filter = null, \StructType\Calculated_Time_Block_Response_GroupType $response_Group = null, $version = null)
    {
        $this
            ->setRequest_References($request_References)
            ->setRequest_Criteria($request_Criteria)
            ->setResponse_Filter($response_Filter)
            ->setResponse_Group($response_Group)
            ->setVersion($version);
    }
    /**
     * Get Request_References value
     * @return \StructType\Calculated_Time_Block_Request_ReferencesType|null
     */
    public function getRequest_References()
    {
        return $this->Request_References;
    }
    /**
     * Set Request_References value
     * @param \StructType\Calculated_Time_Block_Request_ReferencesType $request_References
     * @return \StructType\Get_Calculated_Time_Blocks_RequestType
     */
    public function setRequest_References(\StructType\Calculated_Time_Block_Request_ReferencesType $request_References = null)
    {
        $this->Request_References = $request_References;
        return $this;
    }
    /**
     * Get Request_Criteria value
     * @return \StructType\Calculated_Time_Block_Request_CriteriaType|null
     */
    public function getRequest_Criteria()
    {
        return $this->Request_Criteria;
    }
    /**
     * Set Request_Criteria value
     * @param \StructType\Calculated_Time_Block_Request_CriteriaType $request_Criteria
     * @return \StructType\Get_Calculated_Time_Blocks_RequestType
     */
    public function setRequest_Criteria(\StructType\Calculated_Time_Block_Request_CriteriaType $request_Criteria = null)
    {
        $this->Request_Criteria = $request_Criteria;
        return $this;
    }
    /**
     * Get Response_Filter value
     * @return \StructType\Response_FilterType|null
     */
    public function getResponse_Filter()
    {
        return $this->Response_Filter;
    }
    /**
     * Set Response_Filter value
     * @param \StructType\Response_FilterType $response_Filter
     * @return \StructType\Get_Calculated_Time_Blocks_RequestType
     */
    public function setResponse_Filter(\StructType\Response_FilterType $response_Filter = null)
    {
        $this->Response_Filter = $response_Filter;
        return $this;
    }
    /**
     * Get Response_Group value
     * @return \StructType\Calculated_Time_Block_Response_GroupType|null
     */
    public function getResponse_Group()
    {
        return $this->Response_Group;
    }
    /**
     * Set Response_Group value
     * @param \StructType\Calculated_Time_Block_Response_GroupType $response_Group
     * @return \StructType\Get_Calculated_Time_Blocks_RequestType
     */
    public function setResponse_Group(\StructType\Calculated_Time_Block_Response_GroupType $response_Group = null)
    {
        $this->Response_Group = $response_Group;
        return $this;
    }
    /**
     * Get version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->version;
    }
    /**
     * Set version value
     * @param string $version
     * @return \StructType\Get_Calculated_Time_Blocks_RequestType
     */
    public function setVersion($version = null)
    {
        // validation for constraint: string
        if (!is_null($version) && !is_string($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($version)), __LINE__);
        }
        $this->version = $version;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Get_Calculated_Time_Blocks_RequestType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
