<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Put_Time_Clock_Events_ResponseType StructType
 * Meta informations extracted from the WSDL
 * - documentation: Response element from loading an instance of an External Time Clock Event
 * @subpackage Structs
 */
class Put_Time_Clock_Events_ResponseType extends AbstractStructBase
{
    /**
     * The Response_Text
     * Meta informations extracted from the WSDL
     * - documentation: Response text
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Response_Text;
    /**
     * The version
     * Meta informations extracted from the WSDL
     * - ref: wd:version
     * @var string
     */
    public $version;
    /**
     * Constructor method for Put_Time_Clock_Events_ResponseType
     * @uses Put_Time_Clock_Events_ResponseType::setResponse_Text()
     * @uses Put_Time_Clock_Events_ResponseType::setVersion()
     * @param string $response_Text
     * @param string $version
     */
    public function __construct($response_Text = null, $version = null)
    {
        $this
            ->setResponse_Text($response_Text)
            ->setVersion($version);
    }
    /**
     * Get Response_Text value
     * @return string|null
     */
    public function getResponse_Text()
    {
        return $this->Response_Text;
    }
    /**
     * Set Response_Text value
     * @param string $response_Text
     * @return \StructType\Put_Time_Clock_Events_ResponseType
     */
    public function setResponse_Text($response_Text = null)
    {
        // validation for constraint: string
        if (!is_null($response_Text) && !is_string($response_Text)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($response_Text)), __LINE__);
        }
        $this->Response_Text = $response_Text;
        return $this;
    }
    /**
     * Get version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->version;
    }
    /**
     * Set version value
     * @param string $version
     * @return \StructType\Put_Time_Clock_Events_ResponseType
     */
    public function setVersion($version = null)
    {
        // validation for constraint: string
        if (!is_null($version) && !is_string($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($version)), __LINE__);
        }
        $this->version = $version;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Put_Time_Clock_Events_ResponseType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
